/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 18 "parser.y"

#include "parser.h"
#include <limits.h>

#include "utils.h"

#define abort(...)				\
{						\
	fprintf(stderr, __VA_ARGS__);		\
	YYABORT;				\
}

#define check_and_free_keyword(identifier, expected)			\
{									\
	if (strcmp(identifier, expected))				\
		abort("Wrong keyword: %s expected, %s received\n",	\
		      expected, identifier);				\
	free(identifier);						\
}



#line 94 "parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENTIFIER = 3,                 /* IDENTIFIER  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_SRCFILE = 5,                    /* SRCFILE  */
  YYSYMBOL_CONSTANT = 6,                   /* CONSTANT  */
  YYSYMBOL_NEWLINE = 7,                    /* NEWLINE  */
  YYSYMBOL_TYPEDEF = 8,                    /* TYPEDEF  */
  YYSYMBOL_CONST = 9,                      /* CONST  */
  YYSYMBOL_VOLATILE = 10,                  /* VOLATILE  */
  YYSYMBOL_STRUCT = 11,                    /* STRUCT  */
  YYSYMBOL_UNION = 12,                     /* UNION  */
  YYSYMBOL_ENUM = 13,                      /* ENUM  */
  YYSYMBOL_ELLIPSIS = 14,                  /* ELLIPSIS  */
  YYSYMBOL_VERSION_KW = 15,                /* VERSION_KW  */
  YYSYMBOL_CU_KW = 16,                     /* CU_KW  */
  YYSYMBOL_FILE_KW = 17,                   /* FILE_KW  */
  YYSYMBOL_STACK_KW = 18,                  /* STACK_KW  */
  YYSYMBOL_SYMBOL_KW_NL = 19,              /* SYMBOL_KW_NL  */
  YYSYMBOL_ARROW = 20,                     /* ARROW  */
  YYSYMBOL_UNKNOWN_FIELD = 21,             /* UNKNOWN_FIELD  */
  YYSYMBOL_22_ = 22,                       /* '.'  */
  YYSYMBOL_23_ = 23,                       /* ':'  */
  YYSYMBOL_24_ = 24,                       /* '{'  */
  YYSYMBOL_25_ = 25,                       /* '}'  */
  YYSYMBOL_26_ = 26,                       /* '-'  */
  YYSYMBOL_27_ = 27,                       /* '='  */
  YYSYMBOL_28_ = 28,                       /* '('  */
  YYSYMBOL_29_ = 29,                       /* ')'  */
  YYSYMBOL_30_ = 30,                       /* '*'  */
  YYSYMBOL_31_ = 31,                       /* '['  */
  YYSYMBOL_32_ = 32,                       /* ']'  */
  YYSYMBOL_33_ = 33,                       /* '@'  */
  YYSYMBOL_YYACCEPT = 34,                  /* $accept  */
  YYSYMBOL_kabi_dw_file = 35,              /* kabi_dw_file  */
  YYSYMBOL_fmt_version = 36,               /* fmt_version  */
  YYSYMBOL_header = 37,                    /* header  */
  YYSYMBOL_header_field = 38,              /* header_field  */
  YYSYMBOL_cu_field = 39,                  /* cu_field  */
  YYSYMBOL_source_file_field = 40,         /* source_file_field  */
  YYSYMBOL_stack_field = 41,               /* stack_field  */
  YYSYMBOL_stack_list = 42,                /* stack_list  */
  YYSYMBOL_stack_elt = 43,                 /* stack_elt  */
  YYSYMBOL_symbol = 44,                    /* symbol  */
  YYSYMBOL_alignment = 45,                 /* alignment  */
  YYSYMBOL_declaration = 46,               /* declaration  */
  YYSYMBOL_declaration_typedef = 47,       /* declaration_typedef  */
  YYSYMBOL_declaration_var = 48,           /* declaration_var  */
  YYSYMBOL_type = 49,                      /* type  */
  YYSYMBOL_struct_type = 50,               /* struct_type  */
  YYSYMBOL_struct_list = 51,               /* struct_list  */
  YYSYMBOL_struct_elt = 52,                /* struct_elt  */
  YYSYMBOL_union_type = 53,                /* union_type  */
  YYSYMBOL_enum_type = 54,                 /* enum_type  */
  YYSYMBOL_enum_list = 55,                 /* enum_list  */
  YYSYMBOL_enum_elt = 56,                  /* enum_elt  */
  YYSYMBOL_func_type = 57,                 /* func_type  */
  YYSYMBOL_arg_list = 58,                  /* arg_list  */
  YYSYMBOL_variable_var_list = 59,         /* variable_var_list  */
  YYSYMBOL_elt_list = 60,                  /* elt_list  */
  YYSYMBOL_elt = 61,                       /* elt  */
  YYSYMBOL_ptr_type = 62,                  /* ptr_type  */
  YYSYMBOL_array_type = 63,                /* array_type  */
  YYSYMBOL_typed_type = 64,                /* typed_type  */
  YYSYMBOL_type_qualifier = 65,            /* type_qualifier  */
  YYSYMBOL_base_type = 66,                 /* base_type  */
  YYSYMBOL_reference_file = 67,            /* reference_file  */
  YYSYMBOL_asm_symbol = 68,                /* asm_symbol  */
  YYSYMBOL_weak_symbol = 69                /* weak_symbol  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   151

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  34
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  36
/* YYNRULES -- Number of rules.  */
#define YYNRULES  69
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  143

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   276


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      28,    29,    30,     2,     2,    26,    22,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    23,     2,
       2,    27,     2,     2,    33,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    31,     2,    32,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    24,     2,    25,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    77,    77,    85,    93,    95,    99,   100,   101,   102,
     106,   113,   120,   123,   125,   129,   136,   140,   147,   155,
     156,   157,   158,   159,   160,   161,   162,   166,   173,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   193,   197,
     205,   209,   217,   223,   229,   240,   254,   258,   267,   276,
     280,   288,   296,   304,   313,   316,   320,   328,   336,   340,
     348,   355,   362,   370,   378,   383,   391,   399,   407,   415
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENTIFIER", "STRING",
  "SRCFILE", "CONSTANT", "NEWLINE", "TYPEDEF", "CONST", "VOLATILE",
  "STRUCT", "UNION", "ENUM", "ELLIPSIS", "VERSION_KW", "CU_KW", "FILE_KW",
  "STACK_KW", "SYMBOL_KW_NL", "ARROW", "UNKNOWN_FIELD", "'.'", "':'",
  "'{'", "'}'", "'-'", "'='", "'('", "')'", "'*'", "'['", "']'", "'@'",
  "$accept", "kabi_dw_file", "fmt_version", "header", "header_field",
  "cu_field", "source_file_field", "stack_field", "stack_list",
  "stack_elt", "symbol", "alignment", "declaration", "declaration_typedef",
  "declaration_var", "type", "struct_type", "struct_list", "struct_elt",
  "union_type", "enum_type", "enum_list", "enum_elt", "func_type",
  "arg_list", "variable_var_list", "elt_list", "elt", "ptr_type",
  "array_type", "typed_type", "type_qualifier", "base_type",
  "reference_file", "asm_symbol", "weak_symbol", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-98)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -14,    44,    51,   -98,    -8,   -98,    93,    50,    45,    64,
      48,    78,   -98,   -98,   -98,   -98,   -98,    61,    70,    62,
     -98,     1,    81,    84,    85,    89,   -98,    95,    88,   -98,
     -98,   -98,   -98,   -98,   -98,   -98,   -98,   -98,   -98,    96,
      79,    12,    94,   100,   -98,    98,    91,    92,    97,     3,
     106,   -98,   110,   114,   112,     5,   -98,   -98,   -98,   117,
     115,    63,   118,   -98,   -98,   -98,   -98,   -98,   -98,   -98,
     -98,    63,   -98,   -98,   -98,   -98,    63,   116,   119,   120,
     -98,   -98,   -98,   -98,   101,   -98,   122,   -98,    99,   -98,
     -98,    22,     2,   125,    63,   103,   123,   -98,    63,     6,
     -98,   126,   -98,   -98,   127,   108,   129,   -98,   -98,   130,
     135,   -98,    63,   136,   134,    40,     8,   137,    14,    63,
      49,   138,   -98,   -98,    63,   121,   -98,   -98,   -98,   -98,
     -98,   -98,   -98,   -98,   -98,   -98,   140,    38,    63,   139,
     -98,    63,   -98
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     4,     0,     1,     0,     0,     0,     0,
       0,     0,     9,     5,     6,     7,     8,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     2,     0,     0,    23,
      24,    19,    20,    21,    22,    26,    25,     3,    10,     0,
      12,    68,     0,     0,    53,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,     0,    66,    64,    65,     0,
       0,     0,     0,    28,    31,    32,    33,    34,    35,    36,
      37,     0,    29,    30,    18,    67,     0,     0,     0,     0,
      17,    11,    15,    14,     0,    69,    54,    61,     0,    63,
      27,     0,     0,     0,     0,     0,     0,    58,     0,     0,
      38,     0,    40,    46,     0,     0,     0,    49,    60,     0,
      55,    62,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,    42,     0,     0,    39,    41,    47,    51,
      48,    50,    52,    57,    56,    43,     0,     0,     0,     0,
      44,     0,    45
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -98,   -98,   -98,   -98,   -98,   -98,   -98,   -98,   -98,   -98,
     -98,   -98,   124,   -98,   -98,   -41,    -9,   -98,    26,    -1,
      37,   -98,    30,    43,   -98,   -98,    52,   -97,   -98,   -98,
     -98,   -98,   -98,   -18,   -98,   -98
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     2,     3,     6,    13,    14,    15,    16,    40,    54,
      26,    27,    28,    29,    30,   108,    64,   101,   102,    65,
      66,   106,   107,    67,    95,   121,    96,    97,    68,    69,
      70,    71,    72,    73,    35,    36
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      63,     1,    31,    44,    41,    94,    41,    42,    84,   112,
      32,    94,   113,   122,     7,    55,    56,   105,    31,   122,
      87,    57,    58,    23,    24,    25,    32,   103,    99,   114,
      89,    44,    59,   128,    43,    90,    43,    44,    43,   130,
      60,   138,    61,    62,   139,    43,    99,   100,    33,    18,
       4,     5,    55,    56,    34,    20,    17,   111,    57,    58,
      23,    24,    25,   133,    33,   126,    55,    56,    37,    19,
      34,   123,    57,    58,    23,    24,    25,    38,   132,    61,
      62,    21,    43,   135,    45,    39,    22,    46,    47,    23,
      24,    25,    48,    61,    62,    51,    43,   140,    49,    53,
     142,    74,    52,    22,    75,    76,    23,    24,    25,     8,
       9,    10,    11,    80,    12,    77,    78,    81,    82,    83,
      85,    79,    86,    91,    88,    94,    92,    93,   105,    60,
     110,    98,   109,   115,   116,   117,   118,   119,   120,   124,
     125,   127,   141,   129,   104,   134,   137,   136,   131,     0,
       0,    50
};

static const yytype_int16 yycheck[] =
{
      41,    15,    11,    21,     3,     3,     3,     6,     3,     3,
      11,     3,     6,   110,    22,     3,     4,     3,    27,   116,
      61,     9,    10,    11,    12,    13,    27,    25,     6,    23,
      71,    49,    20,    25,    33,    76,    33,    55,    33,    25,
      28,     3,    30,    31,     6,    33,     6,    25,    11,     4,
       6,     0,     3,     4,    11,     7,     6,    98,     9,    10,
      11,    12,    13,    14,    27,    25,     3,     4,     7,     5,
      27,   112,     9,    10,    11,    12,    13,     7,   119,    30,
      31,     3,    33,   124,     3,    23,     8,     3,     3,    11,
      12,    13,     3,    30,    31,     7,    33,   138,     3,    20,
     141,     7,     6,     8,     4,     7,    11,    12,    13,    16,
      17,    18,    19,     7,    21,    24,    24,     7,     4,     7,
       3,    24,     7,     7,     6,     3,     7,     7,     3,    28,
       7,    32,    29,     7,     7,    27,     7,     7,     3,     3,
       6,   115,     3,     6,    92,     7,     6,    26,   118,    -1,
      -1,    27
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    15,    35,    36,     6,     0,    37,    22,    16,    17,
      18,    19,    21,    38,    39,    40,    41,     6,     4,     5,
       7,     3,     8,    11,    12,    13,    44,    45,    46,    47,
      48,    50,    53,    54,    57,    68,    69,     7,     7,    23,
      42,     3,     6,    33,    67,     3,     3,     3,     3,     3,
      46,     7,     6,    20,    43,     3,     4,     9,    10,    20,
      28,    30,    31,    49,    50,    53,    54,    57,    62,    63,
      64,    65,    66,    67,     7,     4,     7,    24,    24,    24,
       7,     7,     4,     7,     3,     3,     7,    49,     6,    49,
      49,     7,     7,     7,     3,    58,    60,    61,    32,     6,
      25,    51,    52,    25,    60,     3,    55,    56,    49,    29,
       7,    49,     3,     6,    23,     7,     7,    27,     7,     7,
       3,    59,    61,    49,     3,     6,    25,    52,    25,     6,
      25,    56,    49,    14,     7,    49,    26,     6,     3,     6,
      49,     3,    49
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    34,    35,    36,    37,    37,    38,    38,    38,    38,
      39,    40,    41,    42,    42,    43,    44,    44,    45,    46,
      46,    46,    46,    46,    46,    46,    46,    47,    48,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    50,    50,
      51,    51,    52,    52,    52,    52,    53,    53,    54,    55,
      55,    56,    57,    57,    58,    58,    58,    59,    60,    60,
      61,    62,    63,    64,    65,    65,    66,    67,    68,    69
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     4,     5,     0,     2,     1,     1,     1,     1,
       3,     5,     3,     0,     3,     2,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     7,
       1,     3,     3,     4,     7,     8,     5,     7,     7,     1,
       3,     3,     8,     2,     0,     2,     4,     2,     1,     3,
       2,     2,     4,     2,     1,     1,     1,     2,     2,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (root, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, root); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, obj_t **root)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (root);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, obj_t **root)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, root);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, obj_t **root)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], root);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, root); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, obj_t **root)
{
  YY_USE (yyvaluep);
  YY_USE (root);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (obj_t **root)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* kabi_dw_file: fmt_version header SYMBOL_KW_NL symbol  */
#line 78 "parser.y"
        {
		(yyval.obj) = *root = (yyvsp[0].obj);
		obj_fill_parent(*root);
	}
#line 1250 "parser.tab.c"
    break;

  case 3: /* fmt_version: VERSION_KW CONSTANT '.' CONSTANT NEWLINE  */
#line 86 "parser.y"
        {
		if (((yyvsp[-3].ul) != FILEFMT_VERSION_MAJOR) |
		    ((yyvsp[-1].ul) > FILEFMT_VERSION_MINOR))
			abort("Unsupported file version: %lu.%lu\n", (yyvsp[-3].ul), (yyvsp[-1].ul));
	}
#line 1260 "parser.tab.c"
    break;

  case 10: /* cu_field: CU_KW STRING NEWLINE  */
#line 107 "parser.y"
        {
	    free((yyvsp[-1].str));
	}
#line 1268 "parser.tab.c"
    break;

  case 11: /* source_file_field: FILE_KW SRCFILE ':' CONSTANT NEWLINE  */
#line 114 "parser.y"
        {
	    free((yyvsp[-3].str));
	}
#line 1276 "parser.tab.c"
    break;

  case 15: /* stack_elt: ARROW STRING  */
#line 130 "parser.y"
        {
		free((yyvsp[0].str));
	}
#line 1284 "parser.tab.c"
    break;

  case 16: /* symbol: declaration NEWLINE  */
#line 137 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
	}
#line 1292 "parser.tab.c"
    break;

  case 17: /* symbol: alignment declaration NEWLINE  */
#line 141 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1301 "parser.tab.c"
    break;

  case 18: /* alignment: IDENTIFIER CONSTANT NEWLINE  */
#line 148 "parser.y"
        {
		check_and_free_keyword((yyvsp[-2].str), "Alignment");
		(yyval.ul) = (yyvsp[-1].ul);
	}
#line 1310 "parser.tab.c"
    break;

  case 27: /* declaration_typedef: TYPEDEF IDENTIFIER NEWLINE type  */
#line 167 "parser.y"
        {
	    (yyval.obj) = obj_typedef_new_add((yyvsp[-2].str), (yyvsp[0].obj));
	}
#line 1318 "parser.tab.c"
    break;

  case 28: /* declaration_var: IDENTIFIER IDENTIFIER type  */
#line 174 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-2].str), "var");
	    (yyval.obj) = obj_var_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	}
#line 1327 "parser.tab.c"
    break;

  case 38: /* struct_type: STRUCT IDENTIFIER '{' NEWLINE '}'  */
#line 194 "parser.y"
        {
	    (yyval.obj) = obj_struct_new((yyvsp[-3].str));
	}
#line 1335 "parser.tab.c"
    break;

  case 39: /* struct_type: STRUCT IDENTIFIER '{' NEWLINE struct_list NEWLINE '}'  */
#line 198 "parser.y"
        {
	    (yyval.obj) = obj_struct_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	}
#line 1344 "parser.tab.c"
    break;

  case 40: /* struct_list: struct_elt  */
#line 206 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1352 "parser.tab.c"
    break;

  case 41: /* struct_list: struct_list NEWLINE struct_elt  */
#line 210 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1361 "parser.tab.c"
    break;

  case 42: /* struct_elt: CONSTANT IDENTIFIER type  */
#line 218 "parser.y"
        {
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-2].ul);
	}
#line 1370 "parser.tab.c"
    break;

  case 43: /* struct_elt: CONSTANT CONSTANT IDENTIFIER type  */
#line 224 "parser.y"
        {
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-3].ul);
            (yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1380 "parser.tab.c"
    break;

  case 44: /* struct_elt: CONSTANT ':' CONSTANT '-' CONSTANT IDENTIFIER type  */
#line 230 "parser.y"
        {
	    if ((yyvsp[-2].ul) > UCHAR_MAX || (yyvsp[-4].ul) > (yyvsp[-2].ul))
		abort("Invalid offset: %lx:%lu:%lu\n", (yyvsp[-6].ul), (yyvsp[-4].ul), (yyvsp[-2].ul));
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-6].ul);
	    (yyval.obj)->is_bitfield = 1;
	    (yyval.obj)->first_bit = (yyvsp[-4].ul);
	    (yyval.obj)->last_bit = (yyvsp[-2].ul);
	}
#line 1394 "parser.tab.c"
    break;

  case 45: /* struct_elt: CONSTANT ':' CONSTANT '-' CONSTANT CONSTANT IDENTIFIER type  */
#line 241 "parser.y"
        {
	    if ((yyvsp[-3].ul) > UCHAR_MAX || (yyvsp[-5].ul) > (yyvsp[-3].ul))
		abort("Invalid offset: %lx:%lu:%lu\n", (yyvsp[-7].ul), (yyvsp[-5].ul), (yyvsp[-3].ul));
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-7].ul);
	    (yyval.obj)->is_bitfield = 1;
	    (yyval.obj)->first_bit = (yyvsp[-5].ul);
	    (yyval.obj)->last_bit = (yyvsp[-3].ul);
	    (yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1409 "parser.tab.c"
    break;

  case 46: /* union_type: UNION IDENTIFIER '{' NEWLINE '}'  */
#line 255 "parser.y"
        {
	    (yyval.obj) = obj_union_new((yyvsp[-3].str));
	}
#line 1417 "parser.tab.c"
    break;

  case 47: /* union_type: UNION IDENTIFIER '{' NEWLINE elt_list NEWLINE '}'  */
#line 259 "parser.y"
        {
	    (yyval.obj) = obj_union_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	    (yyvsp[-2].list)->object = (yyval.obj);
	}
#line 1427 "parser.tab.c"
    break;

  case 48: /* enum_type: ENUM IDENTIFIER '{' NEWLINE enum_list NEWLINE '}'  */
#line 268 "parser.y"
        {
	    (yyval.obj) = obj_enum_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	    (yyvsp[-2].list)->object = (yyval.obj);
	}
#line 1437 "parser.tab.c"
    break;

  case 49: /* enum_list: enum_elt  */
#line 277 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1445 "parser.tab.c"
    break;

  case 50: /* enum_list: enum_list NEWLINE enum_elt  */
#line 281 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1454 "parser.tab.c"
    break;

  case 51: /* enum_elt: IDENTIFIER '=' CONSTANT  */
#line 289 "parser.y"
        {
	    (yyval.obj) = obj_constant_new((yyvsp[-2].str));
	    (yyval.obj)->constant = (yyvsp[0].ul);
	}
#line 1463 "parser.tab.c"
    break;

  case 52: /* func_type: IDENTIFIER IDENTIFIER '(' NEWLINE arg_list ')' NEWLINE type  */
#line 297 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-7].str), "func");
	    (yyval.obj) = obj_func_new_add((yyvsp[-6].str), (yyvsp[0].obj));
	    (yyval.obj)->member_list = (yyvsp[-3].list);
	    if ((yyvsp[-3].list))
		    (yyvsp[-3].list)->object = (yyval.obj);
	}
#line 1475 "parser.tab.c"
    break;

  case 53: /* func_type: IDENTIFIER reference_file  */
#line 305 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-1].str), "func");
	    (yyval.obj) = obj_func_new_add(NULL, (yyvsp[0].obj));
	}
#line 1484 "parser.tab.c"
    break;

  case 54: /* arg_list: %empty  */
#line 313 "parser.y"
        {
	    (yyval.list) = NULL;
	}
#line 1492 "parser.tab.c"
    break;

  case 55: /* arg_list: elt_list NEWLINE  */
#line 317 "parser.y"
        {
	    (yyval.list) = (yyvsp[-1].list);
	}
#line 1500 "parser.tab.c"
    break;

  case 56: /* arg_list: elt_list NEWLINE variable_var_list NEWLINE  */
#line 321 "parser.y"
        {
	    obj_list_add((yyvsp[-3].list), (yyvsp[-1].obj));
	    (yyval.list) = (yyvsp[-3].list);
	}
#line 1509 "parser.tab.c"
    break;

  case 57: /* variable_var_list: IDENTIFIER ELLIPSIS  */
#line 329 "parser.y"
        {
	    /* TODO: there may be a better solution */
	    (yyval.obj) = obj_var_new_add(NULL, obj_basetype_new(strdup("...")));
	}
#line 1518 "parser.tab.c"
    break;

  case 58: /* elt_list: elt  */
#line 337 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1526 "parser.tab.c"
    break;

  case 59: /* elt_list: elt_list NEWLINE elt  */
#line 341 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1535 "parser.tab.c"
    break;

  case 60: /* elt: IDENTIFIER type  */
#line 349 "parser.y"
        {
	    (yyval.obj) = obj_var_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	}
#line 1543 "parser.tab.c"
    break;

  case 61: /* ptr_type: '*' type  */
#line 356 "parser.y"
        {
	    (yyval.obj) = obj_ptr_new_add((yyvsp[0].obj));
	}
#line 1551 "parser.tab.c"
    break;

  case 62: /* array_type: '[' CONSTANT ']' type  */
#line 363 "parser.y"
        {
	    (yyval.obj) = obj_array_new_add((yyvsp[0].obj));
	    (yyval.obj)->index = (yyvsp[-2].ul);
	}
#line 1560 "parser.tab.c"
    break;

  case 63: /* typed_type: type_qualifier type  */
#line 371 "parser.y"
        {
	    (yyval.obj) = obj_qualifier_new_add((yyvsp[0].obj));
	    (yyval.obj)->base_type = (yyvsp[-1].str);
	}
#line 1569 "parser.tab.c"
    break;

  case 64: /* type_qualifier: CONST  */
#line 379 "parser.y"
        {
	    debug("Qualifier: const\n");
	    (yyval.str) = strdup("const");
	}
#line 1578 "parser.tab.c"
    break;

  case 65: /* type_qualifier: VOLATILE  */
#line 384 "parser.y"
        {
	    debug("Qualifier: volatile\n");
	    (yyval.str) = strdup("volatile");
	}
#line 1587 "parser.tab.c"
    break;

  case 66: /* base_type: STRING  */
#line 392 "parser.y"
        {
	    debug("Base type: %s\n", (yyvsp[0].str));
	    (yyval.obj) = obj_basetype_new((yyvsp[0].str));
	}
#line 1596 "parser.tab.c"
    break;

  case 67: /* reference_file: '@' STRING  */
#line 400 "parser.y"
        {
	    (yyval.obj) = obj_reffile_new();
	    (yyval.obj)->base_type = (yyvsp[0].str);
	    }
#line 1605 "parser.tab.c"
    break;

  case 68: /* asm_symbol: IDENTIFIER IDENTIFIER  */
#line 408 "parser.y"
        {
		check_and_free_keyword((yyvsp[-1].str), "assembly");
		(yyval.obj) = obj_assembly_new((yyvsp[0].str));
	}
#line 1614 "parser.tab.c"
    break;

  case 69: /* weak_symbol: IDENTIFIER IDENTIFIER ARROW IDENTIFIER  */
#line 416 "parser.y"
        {
		check_and_free_keyword((yyvsp[-3].str), "weak");
		(yyval.obj) = obj_weak_new((yyvsp[-2].str));
		(yyval.obj)->link = (yyvsp[0].str);
	}
#line 1624 "parser.tab.c"
    break;


#line 1628 "parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (root, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, root);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, root);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (root, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, root);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, root);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 424 "parser.y"


extern void usage(void);

obj_t *obj_parse(FILE *file, char *fn) {
	obj_t *root = NULL;

#ifdef DEBUG
	yydebug = 1;
#else
	yydebug = 0;
#endif

	yyin = file;
	yyparse(&root);
	if (!root)
		fail("No object build for file %s\n", fn);

	return root;
}

int yyerror(obj_t **root, char *s)
{
	fprintf(stderr, "error: %s\n", s);
	return 0;
}
